<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="类型名称" prop="classifyName">
        <el-input
          v-model="queryParams.classifyName"
          placeholder="请输入类型名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['goods:classify:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['goods:classify:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['goods:classify:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['goods:classify:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="classifyList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="供应商" align="center" prop="supplierId" />
      <el-table-column label="分类图标" align="center" prop="classifyLogo" />
      <el-table-column label="商品类型" align="center" prop="goodsType" />
      <el-table-column label="类型名称" align="center" prop="classifyName" />
      <el-table-column label="备注" align="center" prop="remarks" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['goods:classify:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['goods:classify:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改菜单类型对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="classifyRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="供应商" prop="supplierId">
          <el-input v-model="form.supplierId" placeholder="请输入供应商" />
        </el-form-item>
        <el-form-item label="分类图标" prop="classifyLogo">
          <el-input v-model="form.classifyLogo" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="类型名称" prop="classifyName">
          <el-input v-model="form.classifyName" placeholder="请输入类型名称" />
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Classify">
import { listClassify, getClassify, delClassify, addClassify, updateClassify } from "@/api/goods/classify";

const { proxy } = getCurrentInstance();

const classifyList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(false);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    supplierId: null,
    classifyLogo: null,
    goodsType: null,
    classifyName: null,
    status: null,
    createrCode: null,
    createdate: null,
    updaterCode: null,
    updatedate: null,
    deptId: null,
    remarks: null
  },
  rules: {
    supplierId: [
      { required: true, message: "供应商id不能为空", trigger: "blur" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询菜单类型列表 */
function getList() {
  loading.value = true;
  listClassify(queryParams.value).then(response => {
    classifyList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    classifyId: null,
    supplierId: null,
    classifyLogo: null,
    goodsType: null,
    classifyName: null,
    status: null,
    delFlag: null,
    createrCode: null,
    createdate: null,
    updaterCode: null,
    updatedate: null,
    deptId: null,
    remarks: null
  };
  proxy.resetForm("classifyRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.classifyId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加菜单类型";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _classifyId = row.classifyId || ids.value
  getClassify(_classifyId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改菜单类型";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["classifyRef"].validate(valid => {
    if (valid) {
      if (form.value.classifyId != null) {
        updateClassify(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addClassify(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _classifyIds = row.classifyId || ids.value;
  proxy.$modal.confirm('是否确认删除菜单类型编号为"' + _classifyIds + '"的数据项？').then(function() {
    return delClassify(_classifyIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('goods/classify/export', {
    ...queryParams.value
  }, `classify_${new Date().getTime()}.xlsx`)
}

getList();
</script>
